local Credits = {}
local lg = love.graphics


function Credits:create()
	local credits = {}
	credits.id = "credits"
	credits.z = 0
	credits.screenId = "credits"
	credits.bgColor = { 0, 0, 0 }
	
	-- should not exceed 8 or 9 lines
	credits.lines = {
		"Developed by Maximilian B.",
		"Thanks to Alex for the support",
		"And to everyone who contributes to the lövely community\n @ https://love2d.org/",
		"",
		"Animation script adapted from\n Patrick Rabier (https://github.com/patrixr/love-animation)",
		"Images created by myself or rendered with Stud.io\n (https://www.bricklink.com/v3/studio/download.page)",
		"Music: n91music1@gmail.com (https://n91.itch.io/)",
	}
	credits.font = lg.newFont( 20 )
	
	----------------------------------------------------------------------------------------------------
	
	function credits:open()
		GUImgr:setScreen( self.id )
		
		Music:switchSetToUse( "menu" )
		
		Logger:log( "Open credits menu." )
	end
	
	
	function credits:close()
		Logger:log( "Close credits menu." )
	end
	
	----------------------------------------------------------------------------------------------------
	
	function credits:draw()
		-- if GUImgr:getCurrentScreenId() ~= self.id then
			-- return
		-- end
		
		local x = SCREEN.width * 0.5
		local y = SCREEN.height * 0.1
		local height = SCREEN.height * 0.1
		-- local n = #self.lines
		local wrap = SCREEN.width * 0.8
		
		lg.setFont( self.font )
		for i, line in pairs( self.lines ) do
			lg.printf( line, x - 0.5 * wrap, y + (i-1) * height, wrap, "center" )
		end
		
	end
	
	----------------------------------------------------------------------------------------------------
	
	--[[
	TextScroll:create{
		id = "txtCredits",
		x = SCREEN.width * 0.5,
		y = SCREEN.height * 0.5,
		sizeX = SCREEN.width * 0.3,
		sizeY = SCREEN.height * 0.8,
		screenId = "credits",
		text = "Developed by Maximilian B.\n\n"..
			"Thanks to Alex for the support\n\n\n"..
			"Animation script adapted from\n Patrick Rabier (https://github.com/patrixr/love-animation)\n\n\n"..
			"Images created by myself or rendered with Stud.io (https://www.bricklink.com/v3/studio/download.page)\n\n\n"..
			"Music: n91music1@gmail.com (https://n91.itch.io/)",
		fSize = 22,
		alignMode = "center",
		drawFrame = false,
	}
	--]]
	
	--[[
	Label:create{
		id = "lblCreditsDeveloper",
		x = SCREEN.width * 0.5,
		y = SCREEN.height * 0.1,
		sizeX = SCREEN.width * 0.4,
		sizeY = SCREEN.height * 0.1,
		text = "Developed by Maximilian B.",
		fSize = 22,
		screenId = "credits",
	}
	
	Label:create{
		id = "lblCreditsThanks",
		x = SCREEN.width * 0.5,
		y = SCREEN.height * 0.2,
		sizeX = SCREEN.width * 0.4,
		sizeY = SCREEN.height * 0.1,
		text = "Thanks to Alex for the support",
		fSize = 22,
		screenId = "credits",
	}
	
	Label:create{
		id = "lblCreditsAnimations",
		x = SCREEN.width * 0.5,
		y = SCREEN.height * 0.3,
		sizeX = SCREEN.width * 0.4,
		sizeY = SCREEN.height * 0.1,
		text = "Animation script adapted from\n Patrick Rabier (https://github.com/patrixr/love-animation)",
		fSize = 22,
		screenId = "credits",
	}
	--]]
	
	-- QUIT TO MAIN MENU
	Button:create{
		id = "btnCreditsQuit",
		x = SCREEN.width * 0.9,
		y = SCREEN.height * 0.95,
		shape = "rect",
		sizeX = SCREEN.width * 0.2,
		sizeY = SCREEN.height * 0.1,
		text = "Hauptmenü",
		fSize = 22,
		callback = function()
			credits:close()
			MainMenu:open()
		end,
		screenId = "credits",
	}
	
	----------------------------------------------------------------------------------------------------
	
	GUImgr:addScreen( credits )
	UIRenderer:add( credits )
	
	return credits
end

return Credits
