local Mission = {}

Mission.displayName = "The Drill"

Mission.mapName = "testmap1"

Mission.description = getString( "mission_description_1" )


-- no parameters
function Mission.onGameStart()
	print( "mission 1 started" )
	
	-- test: create a tool store
	do
		local xi = 6
		local yi = 2
		-- EntityManager:createEntity( ENTITIES.buildingArea, { x = (xi-1) * TILESIZE, y = (yi-1) * TILESIZE, xi = xi, yi = yi } )
		local building = EntityManager:createEntity( ENTITIES.toolStore, { x = (xi-1) * TILESIZE, y = (yi-1) * TILESIZE, xi = xi, yi = yi } )
		-- self:onBuildingCreated( building )
		
		local x, y = building:getPosition()
		Camera:setPosition( x, y )
		
	end
	
	-- test: create a teleport pad
	do
		local xi = 7
		local yi = 2
		local building = EntityManager:createEntity( ENTITIES.teleportPad, { x = (xi-1) * TILESIZE, y = (yi-1) * TILESIZE, xi = xi, yi = yi } )
		-- self:onBuildingCreated( building )
	end
	
	-- test: create a vehicle
	do
		local xi = 6
		local yi = 3
		-- EntityManager:createEntity( ENTITIES.transportTruck, { x = (xi-1) * TILESIZE, y = (yi-1) * TILESIZE } )
		EntityManager:createEntity( ENTITIES.digger, { x = 785, y = 320 } )
		-- EntityManager:createEntity( ENTITIES.mobileLaserCutter, { x = (xi-1) * TILESIZE, y = (yi-1) * TILESIZE } )
		-- EntityManager:createEntity( ENTITIES.hoverScout, { x = (xi-1) * TILESIZE, y = (yi-1) * TILESIZE } )
	end
	
	-- test: create a building in a different cave
	do
		local xi = 2
		local yi = 7
		local building = EntityManager:createEntity( ENTITIES.vehicleFactory, { x = (xi-1) * TILESIZE, y = (yi-1) * TILESIZE, xi = xi, yi = yi } )
		local building = EntityManager:createEntity( ENTITIES.robotBay, { x = (xi) * TILESIZE, y = (yi-1) * TILESIZE, xi = xi+1, yi = yi } )
	end
	
	-- test: create a defensive building
	do
		local xi = 6
		local yi = 4
		local building = EntityManager:createEntity( ENTITIES.teslaTower, { x = (xi-1) * TILESIZE, y = (yi-1) * TILESIZE, xi = xi, yi = yi } )
	end
	
	-- test: create a fledder
	EntityManager:createEntity( ENTITIES.fledder, { x = 6 * TILESIZE, y = 2 * TILESIZE } )
	-- EntityManager:createEntity( ENTITIES.fledder, { x = 5 * TILESIZE+10, y = 5 * TILESIZE-10 } )
	
	
	-- mob spawn settings
	-- local spawner = Game.mobSpawner
	-- spawner:setMobSpawnChance( ENTITIES.fledder, 0 )
	-- spawner:disableMobSpawning()
	
	
	-- victory condition
	Game:trackJob( Simplejob:addJob{
		intervall = 1,
		callback = function()
			if GUImgr:getCurrentScreenId() ~= Game.id then
				return true
			end
			if Game.isPaused then return end
			
			if Mission.checkVictoryCondition() then
				Game:victory()
				return true
			end
		end,
	} )
	
end


function Mission.checkVictoryCondition()
	-- test only: collect 10 rock samples to win this mission
	return Game:getPlayerGlobalResource( ENTITIES.rockSample ) >= 10
end


function Mission.onEntityCreated( entity )
	
end


function Mission.onEntityHurtEntity( event )
	
end


-- called after the wall is removed
-- params: entityId, xi and yi tile index
--> the wall with the given entityId does not exist anymore (but maybe the ID is of interest...)
function Mission.onWallDestroyed( entityId, xi, yi )
	
end


-- called before the debris is finally removed
-- params: entity, xi and yi tile index
function Mission.onBeforeDebrisRemoved( debris, xi, yi )
	
	-- test: create a rock sample sometimes
	-- only if the debris does NOT originate from a landslide
	if not debris.createdFromLandslide and math.random() < 0.5 then
		local x, y = tileIndexToPosition( xi, yi )
		EntityManager:createEntity( ENTITIES.rockSample, { x = x, y = y } )
	end
	
end


return Mission
