local Mission = {}

Mission.displayName = "Into the Dark"

Mission.mapName = "testmap2"

Mission.description = getString( "mission_description_2" )


-- no parameters
function Mission.onGameStart()
	print( "mission 2 started" )
	
	-- test: create a tool store
	do
		local xi = 12
		local yi = 6
		local building = EntityManager:createEntity( ENTITIES.toolStore, { x = (xi-1) * TILESIZE, y = (yi-1) * TILESIZE, xi = xi, yi = yi } )
		
		local x, y = building:getPosition()
		Camera:setPosition( x, y )
		
	end
	
	-- test: create a teleport pad
	do
		local xi = 13
		local yi = 6
		local building = EntityManager:createEntity( ENTITIES.teleportPad, { x = (xi-1) * TILESIZE, y = (yi-1) * TILESIZE, xi = xi, yi = yi } )
	end
	
	-- test: create a robot
	do
		local xi = 14
		local yi = 6
		EntityManager:createEntity( ENTITIES.probeDroid, { x = (xi-1) * TILESIZE, y = (yi-1) * TILESIZE } )
	end
	
	-- victory condition
	Game:trackJob( Simplejob:addJob{
		intervall = 1,
		callback = function()
			if GUImgr:getCurrentScreenId() ~= Game.id then
				return true
			end
			if Game.isPaused then return end
			
			if Mission.checkVictoryCondition() then
				Game:victory()
				return true
			end
		end,
	} )
	
end


function Mission.checkVictoryCondition()
	-- test only: collect 10 ore to win this mission
	return Game:getPlayerGlobalResource( ENTITIES.ore ) >= 10
end


function Mission.onEntityCreated( entity )
	
end


function Mission.onEntityHurtEntity( event )
	
end


return Mission
