local OhwEntitySelection = {}
local lg = love.graphics

--[[
data:
entityId
width
height
offsetY
--]]

function OhwEntitySelection:create( data )
	local widget = {}
	
	-- widget.x = data.x
	-- widget.y = data.y
	widget.entityId = data.entityId
	widget.visible = true
	widget.imageData = Images["entity_selection_frame_1"]
	widget.scaleX = data.width / widget.imageData.image:getWidth()
	widget.scaleY = data.height / widget.imageData.image:getHeight()
	widget.offsetY = data.offsetY or 0
	
	widget.rendererLayer = "overhead"
	
	----------------------------------------------------------------------------------------------------
	
	function widget:setVisible( visibility )
		self.visible = visibility
	end
	
	----------------------------------------------------------------------------------------------------
	
	function widget:draw()
		if not self.visible then return end
		
		local entity = EntityManager:getEntityById( self.entityId )
		if not entity then return end
		
		local x, y = convertToDimetric( entity:getPosition() )
		
		local imgData = self.imageData
		local sx = self.scaleX
		local sy = self.scaleY
		local ox = imgData.ox or 0
		local oy = imgData.oy or 0
		lg.draw( imgData.image, x, y - self.offsetY, 0, sx, sy, ox, oy )
	end
	
	----------------------------------------------------------------------------------------------------
	
	function widget:destroy()
		Renderer:remove( self, self.rendererLayer )
		self = nil
	end
	
	----------------------------------------------------------------------------------------------------
	
	Renderer:add( widget, widget.rendererLayer )
	
	return widget
end

return OhwEntitySelection
