local widget = {}
local lg = love.graphics

function widget:create(data)
	local w = {}
	w.id = data.id
	w.z = 1
	w.screenId = data.screenId
	w.canHaveChilds = true	-- see guimgr (toggle visibility = toggle child visibility)
	w.canHover = false
	w.canClick = true	-- act as click cather = do not let mouse clicks through to interact with game objects
	
	w.body = {}
	w.body.shape = data.shape or "rect"
	w.body.sizeX = data.sizeX or 100
	w.body.sizeY = data.sizeY or 100
	w.body.x = data.x or 0
	w.body.y = data.y or 0
	w.body.z = data.z or 1
	
	if data.enabled == nil then
		w.enabled = true
	else
		w.enabled = data.enabled
	end
	if data.visible == nil then
		w.visible = true
	else
		w.visible = data.visible
	end
	
	
	function w:getShape()
		return self.body
	end
	
	
	function w:tick(dt)
	
	end
	
	
	function w:draw()
		if not self.visible then
			return
		end
		
		local body = self.body
		lg.setColor( 0.1, 0.1, 0.1, 0.8 )
		lg.rectangle( "fill", body.x - body.sizeX * 0.5, body.y - body.sizeY * 0.5, body.sizeX, body.sizeY )
		lg.setColor( 1, 1, 1, 1 )
		lg.rectangle( "line", body.x - body.sizeX * 0.5, body.y - body.sizeY * 0.5, body.sizeX, body.sizeY )
		
	end
	
	
	GUImgr:addObject( w )
	UIRenderer:add( w )
	
	return w
end


return widget
