local Images = {}
local lg = love.graphics


local dirTerrain = "images/terrain/"
local dirWalls = "images/walls/"
local dirBuildings = "images/buildings/"
local dirEntities = "images/entities/"
local dirIcons = "images/icons/"

----------------------------------------------------------------------------------------------------

-- terrain
Images["ground_normal_dirt"] = { image = lg.newImage( dirTerrain.."dirt.png") }	-- combined dirt + erosive
Images["ground_normal_water"] = { image = lg.newImage( dirTerrain.."water.png") }
Images["ground_normal_lava"] = { image = lg.newImage( dirTerrain.."lava.png") }

----------------------------------------------------------------------------------------------------

-- walls (offset = center at floor level, x = half the image width, y is usually greater than half the height)
Images["wall_normal_hard_rock_full"] = { image = lg.newImage( dirWalls.."normal/hard rock/inner full.png"), ox = 125, oy = 161 }
Images["wall_normal_hard_rock_straight_1"] = { image = lg.newImage( dirWalls.."normal/hard rock/straight 1.png"), ox = 125, oy = 161 }
Images["wall_normal_hard_rock_straight_2"] = { image = lg.newImage( dirWalls.."normal/hard rock/straight 2.png"), ox = 125, oy = 161 }
Images["wall_normal_hard_rock_straight_3"] = { image = lg.newImage( dirWalls.."normal/hard rock/straight 3.png"), ox = 125, oy = 139 }	-- or 138
Images["wall_normal_hard_rock_straight_4"] = { image = lg.newImage( dirWalls.."normal/hard rock/straight 4.png"), ox = 125, oy = 139 }
Images["wall_normal_hard_rock_corner_1"] = { image = lg.newImage( dirWalls.."normal/hard rock/corner 1.png"), ox = 125, oy = 161 }
Images["wall_normal_hard_rock_corner_2"] = { image = lg.newImage( dirWalls.."normal/hard rock/corner 2.png"), ox = 125, oy = 147 }
Images["wall_normal_hard_rock_corner_3"] = { image = lg.newImage( dirWalls.."normal/hard rock/corner 3.png"), ox = 125, oy = 115 }
Images["wall_normal_hard_rock_corner_4"] = { image = lg.newImage( dirWalls.."normal/hard rock/corner 4.png"), ox = 125, oy = 147 }
Images["wall_normal_hard_rock_inner_corner_1"] = { image = lg.newImage( dirWalls.."normal/hard rock/inner corner 1.png"), ox = 125, oy = 161 }
Images["wall_normal_hard_rock_inner_corner_2"] = { image = lg.newImage( dirWalls.."normal/hard rock/inner corner 2.png"), ox = 125, oy = 161 }
Images["wall_normal_hard_rock_inner_corner_3"] = { image = lg.newImage( dirWalls.."normal/hard rock/inner corner 3.png"), ox = 125, oy = 161 }
Images["wall_normal_hard_rock_inner_corner_4"] = { image = lg.newImage( dirWalls.."normal/hard rock/inner corner 4.png"), ox = 125, oy = 139 }
Images["wall_normal_hard_rock_double_inner_corner_1"] = { image = lg.newImage( dirWalls.."normal/hard rock/double inner corner 1.png"), ox = 125, oy = 161 }
Images["wall_normal_hard_rock_double_inner_corner_2"] = { image = lg.newImage( dirWalls.."normal/hard rock/double inner corner 2.png"), ox = 125, oy = 146 }

-- walls (offset = center at floor level, x = half the image width, y is usually greater than half the height)
Images["wall_normal_solid_rock_full"] = { image = lg.newImage( dirWalls.."normal/solid rock/inner full.png"), ox = 125, oy = 161 }
Images["wall_normal_solid_rock_straight_1"] = { image = lg.newImage( dirWalls.."normal/solid rock/straight 1.png"), ox = 125, oy = 161 }
Images["wall_normal_solid_rock_straight_2"] = { image = lg.newImage( dirWalls.."normal/solid rock/straight 2.png"), ox = 125, oy = 161 }
Images["wall_normal_solid_rock_straight_3"] = { image = lg.newImage( dirWalls.."normal/solid rock/straight 3.png"), ox = 125, oy = 139 }	-- or 138
Images["wall_normal_solid_rock_straight_4"] = { image = lg.newImage( dirWalls.."normal/solid rock/straight 4.png"), ox = 125, oy = 131 }
Images["wall_normal_solid_rock_corner_1"] = { image = lg.newImage( dirWalls.."normal/solid rock/corner 1.png"), ox = 125, oy = 161 }
Images["wall_normal_solid_rock_corner_2"] = { image = lg.newImage( dirWalls.."normal/solid rock/corner 2.png"), ox = 125, oy = 138 }
Images["wall_normal_solid_rock_corner_3"] = { image = lg.newImage( dirWalls.."normal/solid rock/corner 3.png"), ox = 125, oy = 114 }
Images["wall_normal_solid_rock_corner_4"] = { image = lg.newImage( dirWalls.."normal/solid rock/corner 4.png"), ox = 125, oy = 138 }
Images["wall_normal_solid_rock_inner_corner_1"] = { image = lg.newImage( dirWalls.."normal/solid rock/inner corner 1.png"), ox = 125, oy = 161 }
Images["wall_normal_solid_rock_inner_corner_2"] = { image = lg.newImage( dirWalls.."normal/solid rock/inner corner 2.png"), ox = 125, oy = 161 }
Images["wall_normal_solid_rock_inner_corner_3"] = { image = lg.newImage( dirWalls.."normal/solid rock/inner corner 3.png"), ox = 125, oy = 161 }
Images["wall_normal_solid_rock_inner_corner_4"] = { image = lg.newImage( dirWalls.."normal/solid rock/inner corner 4.png"), ox = 125, oy = 139 }
Images["wall_normal_solid_rock_double_inner_corner_1"] = { image = lg.newImage( dirWalls.."normal/solid rock/double inner corner 1.png"), ox = 125, oy = 161 }
Images["wall_normal_solid_rock_double_inner_corner_2"] = { image = lg.newImage( dirWalls.."normal/solid rock/double inner corner 2.png"), ox = 125, oy = 146 }

-- walls (offset = center at floor level, x = half the image width, y is usually greater than half the height)
Images["wall_normal_loose_rock_full"] = { image = lg.newImage( dirWalls.."normal/loose rock/inner full.png"), ox = 125, oy = 161 }
Images["wall_normal_loose_rock_straight_1"] = { image = lg.newImage( dirWalls.."normal/loose rock/straight 1.png"), ox = 125, oy = 161 }
Images["wall_normal_loose_rock_straight_2"] = { image = lg.newImage( dirWalls.."normal/loose rock/straight 2.png"), ox = 125, oy = 161 }
Images["wall_normal_loose_rock_straight_3"] = { image = lg.newImage( dirWalls.."normal/loose rock/straight 3.png"), ox = 125, oy = 139 }	-- or 138
Images["wall_normal_loose_rock_straight_4"] = { image = lg.newImage( dirWalls.."normal/loose rock/straight 4.png"), ox = 125, oy = 131 }
Images["wall_normal_loose_rock_corner_1"] = { image = lg.newImage( dirWalls.."normal/loose rock/corner 1.png"), ox = 125, oy = 161 }
Images["wall_normal_loose_rock_corner_2"] = { image = lg.newImage( dirWalls.."normal/loose rock/corner 2.png"), ox = 125, oy = 146 }
Images["wall_normal_loose_rock_corner_3"] = { image = lg.newImage( dirWalls.."normal/loose rock/corner 3.png"), ox = 125, oy = 114 }
Images["wall_normal_loose_rock_corner_4"] = { image = lg.newImage( dirWalls.."normal/loose rock/corner 4.png"), ox = 125, oy = 146 }
Images["wall_normal_loose_rock_inner_corner_1"] = { image = lg.newImage( dirWalls.."normal/loose rock/inner corner 1.png"), ox = 125, oy = 161 }
Images["wall_normal_loose_rock_inner_corner_2"] = { image = lg.newImage( dirWalls.."normal/loose rock/inner corner 2.png"), ox = 125, oy = 161 }
Images["wall_normal_loose_rock_inner_corner_3"] = { image = lg.newImage( dirWalls.."normal/loose rock/inner corner 3.png"), ox = 125, oy = 161 }
Images["wall_normal_loose_rock_inner_corner_4"] = { image = lg.newImage( dirWalls.."normal/loose rock/inner corner 4.png"), ox = 125, oy = 139 }
Images["wall_normal_loose_rock_double_inner_corner_1"] = { image = lg.newImage( dirWalls.."normal/loose rock/double inner corner 1.png"), ox = 125, oy = 161 }
Images["wall_normal_loose_rock_double_inner_corner_2"] = { image = lg.newImage( dirWalls.."normal/loose rock/double inner corner 2.png"), ox = 125, oy = 146 }

----------------------------------------------------------------------------------------------------

-- buildings
Images["building_area_1"] = { image = lg.newImage( dirBuildings.."building area 2.png"), ox = 125, oy = 69 }	-- 77
Images["construction_site_1"] = { image = lg.newImage( dirBuildings.."construction site 1.png"), ox = 125, oy = 77 }
Images["construction_site_2"] = { image = lg.newImage( dirBuildings.."construction site 2.png"), ox = 125, oy = 66 }
Images["tool_store_1"] = { image = lg.newImage( dirBuildings.."tool store test 3.png"), ox = 125, oy = 90 }
Images["teleport_pad_1"] = { image = lg.newImage( dirBuildings.."teleport pad 1.png"), ox = 125, oy = 84 }
Images["robot_bay_1"] = { image = lg.newImage( dirBuildings.."robot bay.png"), ox = 125, oy = 92 }
Images["vehicle_factory_1"] = { image = lg.newImage( dirBuildings.."vehicle factory.png"), ox = 125, oy = 118 }
Images["tesla_tower_1"] = { image = lg.newImage( dirBuildings.."tesla tower.png"), ox = 125, oy = 102 }
Images["water_gun_tower_1"] = { image = lg.newImage( dirBuildings.."/water gun tower/water gun tower 1.png"), ox = 125, oy = 177 }
Images["water_gun_tower_2"] = { image = lg.newImage( dirBuildings.."/water gun tower/water gun tower 2.png"), ox = 125, oy = 177 }

Images["support_station_1"] = { image = lg.newImage( dirBuildings.."/support station/normal.png") }	-- animated

-- other buildings
Images["construction_fence_1"] = { image = lg.newImage( dirBuildings.."construction fence 1.png"), ox = 64, oy = 90 }
Images["construction_fence_2"] = { image = lg.newImage( dirBuildings.."construction fence 2.png"), ox = 64, oy = 90 }
Images["construction_fence_3"] = { image = lg.newImage( dirBuildings.."construction fence 3.png"), ox = 64, oy = 90 }
Images["construction_fence_4"] = { image = lg.newImage( dirBuildings.."construction fence 4.png"), ox = 64, oy = 90 }

----------------------------------------------------------------------------------------------------

-- units
Images["rock_raider_idle_1"] = { image = lg.newImage( dirEntities.."rock raider/idle.png") }	-- animated
Images["rock_raider_carry_idle_1"] = { image = lg.newImage( dirEntities.."rock raider/carry idle.png") }
Images["rock_raider_walk_1"] = { image = lg.newImage( dirEntities.."rock raider/walk.png") }
Images["rock_raider_carry_walk_1"] = { image = lg.newImage( dirEntities.."rock raider/carry walk.png") }
Images["rock_raider_drill_1"] = { image = lg.newImage( dirEntities.."rock raider/drill.png") }
Images["rock_raider_reinforce_wall_1"] = { image = lg.newImage( dirEntities.."rock raider/reinforce wall.png") }
Images["rock_raider_shovel_1"] = { image = lg.newImage( dirEntities.."rock raider/shovel.png") }

-- oy are just guesses for the vehicles
Images["hover_scout_empty_1"] = { image = lg.newImage( dirEntities.."hover scout/empty.png") }
Images["hover_scout_driver_1"] = { image = lg.newImage( dirEntities.."hover scout/driver.png") }

Images["digger_empty_1"] = { image = lg.newImage( dirEntities.."digger/empty 1.png") }
Images["digger_driver_1"] = { image = lg.newImage( dirEntities.."digger/driver idle.png") }	-- animated
Images["digger_drill_1"] = { image = lg.newImage( dirEntities.."digger/drill.png") }

Images["transport_truck_empty_1"] = { image = lg.newImage( dirEntities.."transport truck/empty.png") }	-- animated
Images["transport_truck_driver_idle_1"] = { image = lg.newImage( dirEntities.."transport truck/driver idle.png") }
Images["transport_truck_driving_1"] = { image = lg.newImage( dirEntities.."transport truck/driving.png") }

Images["mobile_laser_cutter_drill_1"] = { image = lg.newImage( dirEntities.."mobile laser cutter/drill.png") }	-- animated
Images["mobile_laser_cutter_empty_1"] = { image = lg.newImage( dirEntities.."mobile laser cutter/empty.png") }
Images["mobile_laser_cutter_driver_1"] = { image = lg.newImage( dirEntities.."mobile laser cutter/drill.png") }	-- TODO needs a different animation

Images["probe_droid_idle_1"] = { image = lg.newImage( dirEntities.."probe droid/idle.png") }
Images["probe_droid_scan_1"] = { image = lg.newImage( dirEntities.."probe droid/scan.png") }

----------------------------------------------------------------------------------------------------

-- mobs
Images["fledder_flying_1"] = { image = lg.newImage( dirEntities.."fledder/flying.png") }
Images["carl_idle_1"] = { image = lg.newImage( dirEntities.."carl/idle.png") }
Images["carl_walk_1"] = { image = lg.newImage( dirEntities.."carl/walk.png") }

----------------------------------------------------------------------------------------------------

-- resources
Images["ore_normal"] = { image = lg.newImage( dirEntities.."ore.png"), ox = 32, oy = 56 }
Images["ore_gray"] = { image = lg.newImage( dirEntities.."ore gray.png"), ox = 32, oy = 56 }
Images["energy_crystal"] = { image = lg.newImage( dirEntities.."energy crystal.png"), ox = 32, oy = 56 }
Images["rock_sample_1"] = { image = lg.newImage( dirEntities.."rock sample 1.png"), ox = 32, oy = 56 }
Images["rock_sample_2"] = { image = lg.newImage( dirEntities.."rock sample 2.png"), ox = 32, oy = 56 }
Images["rock_sample_3"] = { image = lg.newImage( dirEntities.."rock sample 3.png"), ox = 32, oy = 56 }
Images["rock_sample_4"] = { image = lg.newImage( dirEntities.."rock sample 4.png"), ox = 32, oy = 56 }
Images["rock_sample_5"] = { image = lg.newImage( dirEntities.."rock sample 5.png"), ox = 32, oy = 56 }

----------------------------------------------------------------------------------------------------

-- icons
Images["icon_drill_wall"] = { image = lg.newImage( dirIcons.."drill wall.png"), ox = 32, oy = 32 }	-- size 64x64
Images["icon_reinforce_wall"] = { image = lg.newImage( dirIcons.."reinforce wall.png"), ox = 32, oy = 32 }
Images["icon_clear_debris"] = { image = lg.newImage( dirIcons.."clear debris.png"), ox = 32, oy = 32 }
Images["icon_collect_energy_crystal"] = { image = lg.newImage( dirIcons.."collect energy crystal.png"), ox = 32, oy = 32 }
Images["icon_collect_ore"] = { image = lg.newImage( dirIcons.."collect ore.png"), ox = 32, oy = 32 }
Images["icon_collect_rock_sample"] = { image = lg.newImage( dirIcons.."collect rock sample.png"), ox = 32, oy = 32 }
Images["icon_construct_building"] = { image = lg.newImage( dirIcons.."construct building.png"), ox = 32, oy = 32 }
Images["icon_vehicle"] = { image = lg.newImage( dirIcons.."vehicle.png"), ox = 32, oy = 32 }
Images["icon_vehicle_get_driver"] = { image = lg.newImage( dirIcons.."vehicle get driver.png"), ox = 32, oy = 32 }
Images["icon_vehicle_driver_leave"] = { image = lg.newImage( dirIcons.."vehicle driver leave.png"), ox = 32, oy = 32 }
Images["icon_swap_priorities"] = { image = lg.newImage( dirIcons.."swap priorities.png"), ox = 32, oy = 32 }
Images["icon_rock_raider_1"] = { image = lg.newImage( dirIcons.."rock raider 1.png"), ox = 32, oy = 32 }
Images["icon_rock_raider_frontal"] = { image = lg.newImage( dirIcons.."rock raider frontal.png"), ox = 32, oy = 32 }
Images["icon_settings"] = { image = lg.newImage( dirIcons.."settings.png"), ox = 32, oy = 32 }
Images["icon_yes"] = { image = lg.newImage( dirIcons.."yes.png"), ox = 32, oy = 32 }
Images["icon_no"] = { image = lg.newImage( dirIcons.."no.png"), ox = 32, oy = 32 }
Images["icon_radar_1"] = { image = lg.newImage( dirIcons.."radar.png"), ox = 16, oy = 16 }	-- 32x32
Images["icon_minimap"] = { image = lg.newImage( dirIcons.."minimap.png"), ox = 32, oy = 32 }
Images["icon_destroy_building"] = { image = lg.newImage( dirIcons.."cancel building.png"), ox = 32, oy = 32 }
Images["icon_cancel_building"] = { image = lg.newImage( dirIcons.."cancel building.png"), ox = 32, oy = 32 }
Images["icon_expell_unit"] = { image = lg.newImage( dirIcons.."expell unit.png"), ox = 32, oy = 32 }

Images["icon_tool_store"] = { image = lg.newImage( dirIcons.."tool store.png"), ox = 32, oy = 32 }
Images["icon_teleport_pad"] = { image = lg.newImage( dirIcons.."teleport pad.png"), ox = 32, oy = 32 }
Images["icon_robot_bay"] = { image = lg.newImage( dirIcons.."robot bay.png"), ox = 32, oy = 32 }
Images["icon_tesla_tower"] = { image = lg.newImage( dirIcons.."tesla tower.png"), ox = 32, oy = 32 }
Images["icon_water_gun_tower"] = { image = lg.newImage( dirIcons.."water gun tower.png"), ox = 32, oy = 32 }
Images["icon_support_station"] = { image = lg.newImage( dirIcons.."support station.png"), ox = 32, oy = 32 }
Images["icon_vehicle_factory"] = { image = lg.newImage( dirIcons.."vehicle factory.png"), ox = 32, oy = 32 }

Images["icon_digger"] = { image = lg.newImage( dirIcons.."digger.png"), ox = 32, oy = 32 }
Images["icon_transport_truck"] = { image = lg.newImage( dirIcons.."transport truck.png"), ox = 32, oy = 32 }
Images["icon_hover_scout"] = { image = lg.newImage( dirIcons.."hover scout.png"), ox = 32, oy = 32 }
Images["icon_mobile_laser_cutter"] = { image = lg.newImage( dirIcons.."mobile laser cutter.png"), ox = 32, oy = 32 }

Images["icon_probe_droid"] = { image = lg.newImage( dirIcons.."probe droid.png"), ox = 32, oy = 32 }

Images["icon_solid_rock"] = { image = lg.newImage( dirIcons.."solid rock.png"), ox = 32, oy = 32 }
Images["icon_hard_rock"] = { image = lg.newImage( dirIcons.."hard rock.png"), ox = 32, oy = 32 }
Images["icon_loose_rock"] = { image = lg.newImage( dirIcons.."loose rock.png"), ox = 32, oy = 32 }
Images["icon_terrain_dirt"] = { image = lg.newImage( dirIcons.."dirt.png"), ox = 32, oy = 32 }
Images["icon_terrain_water"] = { image = lg.newImage( dirIcons.."water.png"), ox = 32, oy = 32 }
Images["icon_terrain_lava"] = { image = lg.newImage( dirIcons.."lava.png"), ox = 32, oy = 32 }

----------------------------------------------------------------------------------------------------

-- other
Images["debris_normal_full"] = { image = lg.newImage( "images/debris 1.png"), ox = 125, oy = 67 }
Images["debris_normal_half"] = { image = lg.newImage( "images/debris 2.png"), ox = 125, oy = 52 }
Images["debris_normal_small"] = { image = lg.newImage( "images/debris 3.png"), ox = 125, oy = 52 }

Images["entity_selection_frame_1"] = { image = lg.newImage( "images/selection frame 1.png"), ox = 16, oy = 16 }

Images["light_round"] = { image = lg.newImage( "images/light_round_1.png"), width = 128, height = 128, ox = 64, oy = 64 }
Images["light_cone"] = { image = lg.newImage( "images/light_cone_1.png"), width = 128, height = 128, ox = 64, oy = 64 }

Images["thought_bubbles"] = { image = lg.newImage( "images/thought_bubbles.png"), width = 64, height = 64, ox = 32, oy = 32 }


return Images
